package insistesoft.multixnotes;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.design.widget.TextInputEditText;
import android.support.design.widget.TextInputLayout;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.Gravity;
import android.view.inputmethod.InputMethodManager;
import android.support.annotation.NonNull;
import android.os.Bundle;
import android.text.TextUtils;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

public class ConnecActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_connec);

        final TextInputEditText etUsuari = (TextInputEditText) findViewById(R.id.etUsuari);
        final TextInputEditText etPwd = (TextInputEditText) findViewById(R.id.etPwd);
        final TextInputLayout tilUsuari = (TextInputLayout) findViewById(R.id.tilusuari);
        final TextInputLayout tilPwd = (TextInputLayout) findViewById(R.id.tilPwd);
        final Button btLoggin = (Button) findViewById(R.id.btLoggin);

        final Context ctx = this;
        SharedPreferences spAcces = getSharedPreferences("dadesacces", ctx.MODE_PRIVATE);

        final String usuari = spAcces.getString("nomusuari", "NULL");
        final String contrasenya = spAcces.getString("contrasenya", "NULL");
        Log.i("pwd-loggin", contrasenya);

        if(usuari.equals("NULL")) { btLoggin.setText(getResources().getString(R.string.reg_loggin)); }

        final SharedPreferences finalSpAcces = spAcces;

        btLoggin.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(!TextUtils.isEmpty(etUsuari.getText()) && !TextUtils.isEmpty(etPwd.getText())) {
                    if (usuari.equals("NULL")) {

                        SharedPreferences.Editor edituser = finalSpAcces.edit();
                        edituser.putString("nomusuari", etUsuari.getText().toString());
                        edituser.putString("contrasenya", etPwd.getText().toString());
                        edituser.commit();
                        Intent intent = new Intent().setClass(ConnecActivity.this, DocentActivityAcc.class);
                        startActivity(intent);
                        finish();

                    } else if (usuari.equals(etUsuari.getText().toString()) && contrasenya.equals(etPwd.getText().toString())) {

                        Intent intent = new Intent().setClass(ConnecActivity.this, DocentActivityAcc.class);
                        startActivity(intent);
                        finish();

                    } else {
                        Toast toast = Toast.makeText(getApplicationContext(), getResources().getString(R.string.errordades), Toast.LENGTH_LONG);
                        toast.setGravity(Gravity.CENTER,0,0);
                        toast.show();

                        clearFocus();
                    }
                } else {

                    String usuariError = null;
                    if(TextUtils.isEmpty(etUsuari.getText())) {
                        usuariError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilUsuari, usuariError);

                    String passError = null;
                    if (TextUtils.isEmpty(etPwd.getText())) {
                        passError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilPwd, passError);

                    clearFocus();
                }
            }
        });
    }

    /**
     * Display/hides TextInputLayout error.
     *
     * @param msg the message, or null to hide
     */
    private static void toggleTextInputLayoutError(@NonNull TextInputLayout textInputLayout,
                                                   String msg) {
        textInputLayout.setError(msg);
        if (msg == null) {
            textInputLayout.setErrorEnabled(false);
        } else {
            textInputLayout.setErrorEnabled(true);
        }
    }

    private void clearFocus() {
        View view = this.getCurrentFocus();
        if (view != null && view instanceof EditText) {
            InputMethodManager inputMethodManager = (InputMethodManager) getSystemService(Context
                    .INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(view.getWindowToken(), 0);
            view.clearFocus();
        }
    }
}
