package insistesoft.multixnotes;

import android.content.Context;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.design.widget.TextInputEditText;
import android.support.design.widget.TextInputLayout;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.util.Log;
import android.view.Gravity;
import android.view.View;
import android.support.design.widget.NavigationView;
import android.support.v4.view.GravityCompat;
import android.support.v4.widget.DrawerLayout;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.Menu;
import android.view.MenuItem;
import android.view.inputmethod.InputMethodManager;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.Arrays;

import insistesoft.multixnotes.beans.Student;
import insistesoft.multixnotes.beans.StudentsMarks;
import insistesoft.multixnotes.beans.Subject;
import insistesoft.multixnotes.beans.TypePercentQual;
import insistesoft.multixnotes.tools.TotalMarkFormat;

public class DocentActivityAcc extends AppCompatActivity implements NavigationView.OnNavigationItemSelectedListener {

    View contentdocentactivityacc, currentView, contentafegirestudiant, contentafegirassig, contentafegirnota, contentafegirtipus;
    View contentmostrarnotes;
    View contentconfig, contentmodest, contentmodassig, contentmodnota;

    final Context contxt = this;
    GestorMxNInterface gestormxn = new GestorMxNImplement();

    int currentStudent;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_docent_acc2);
        Toolbar toolbar = (Toolbar) findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);


        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        ActionBarDrawerToggle toggle = new ActionBarDrawerToggle(
                this, drawer, toolbar, R.string.navigation_drawer_open, R.string.navigation_drawer_close);
        drawer.setDrawerListener(toggle);
        toggle.syncState();

        NavigationView navigationView = (NavigationView) findViewById(R.id.nav_view);
        navigationView.setNavigationItemSelectedListener(this);

        contentdocentactivityacc = findViewById(R.id.content_docent_activity_acc);
        currentView = contentdocentactivityacc;

        //contents to add new objects
        contentafegirassig = findViewById(R.id.content_docent_activity_afegirassig);
        contentafegirassig.setEnabled(false);
        contentafegirestudiant = findViewById(R.id.content_docent_activity_afegirest);
        contentafegirestudiant.setEnabled(false);
        contentafegirnota = findViewById(R.id.content_docent_activity_afegirnota);
        contentafegirnota.setEnabled(false);
        contentafegirtipus = findViewById(R.id.content_docent_activity_afegirtipus);
        contentafegirtipus.setEnabled(false);

        //content to show qualifications
        contentmostrarnotes = findViewById(R.id.content_docent_activity_mostrarnotes);
        contentmostrarnotes.setEnabled(false);

        //contents to modify objects
        contentconfig = findViewById(R.id.content_docent_activity_config);
        contentconfig.setEnabled(false);
        contentmodassig = findViewById(R.id.content_docent_activity_modassig);
        contentmodassig.setEnabled(false);
        contentmodest = findViewById(R.id.content_docent_activity_modest);
        contentmodest.setEnabled(false);
        contentmodnota = findViewById(R.id.content_docent_activity_modnota);
        contentmodnota.setEnabled(false);

        //shows first screen by the next operation
        switch (gestormxn.firstScreen(contxt)) {
            case 1: //content new subject
                activeAddSubject();
                break;
            case 2: //content new student
                activeAddStudent();
                break;
            case 3: //content new qualification
                activeAddQualification();
                break;
        }
    }

    @Override
    public void onBackPressed() {
        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        if (drawer.isDrawerOpen(GravityCompat.START)) {
            drawer.closeDrawer(GravityCompat.START);
        } else {
            super.onBackPressed();
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.docent_activity_acc, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {

        int id = item.getItemId();

        if (id == R.id.editarconfig) {
            activeEditConfig();
            return true;
        }
        if (id == R.id.logout) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @SuppressWarnings("StatementWithEmptyBody")
    @Override
    public boolean onNavigationItemSelected(@NonNull MenuItem item) {

        switch (item.getItemId()) {

            //add qualification
            case R.id.afegirnota:
                activeAddQualification();
                break;
            //edit qualification
            case R.id.editarnota:
                activeModQual(true);
                break;
            //edit evaluation method
            case R.id.editartipus:
                activeModQual(false);
                break;
            //add student
            case R.id.afegirestudiant:
                activeAddStudent();
                break;
            //edit student
            case R.id.editarestudiant:
                activeModStudent();
                break;
            //add subject
            case R.id.afegirassig:
                activeAddSubject();
                break;
            //edit subject
            case R.id.editarassig:
                activeModSubject();
                break;
            //show qualifications
            case R.id.mostrarnota:
                activeShowQualification();
                break;
            // add new type
            case R.id.afegirtipus:
                activeAddType();
                break;
        }

        DrawerLayout drawer = (DrawerLayout) findViewById(R.id.drawer_layout);
        drawer.closeDrawer(GravityCompat.START);
        return true;
    }

    public void activeNextView(View nextView) {
        if (!currentView.equals(null)) {
            currentView.setVisibility(View.INVISIBLE);
            currentView.setEnabled(false);
        }
        nextView.setEnabled(true);
        nextView.setVisibility(View.VISIBLE);
        currentView = nextView;
    }

    // ---- Actions to active menu options -----

    /**
     * Show and active the content to add a new subject
     */
    public void activeAddSubject() {
        activeNextView(contentafegirassig);
        final TextInputLayout tilAddSubjC = (TextInputLayout) findViewById(R.id.tilafegirassig);
        final TextInputLayout tilAddSubjN = (TextInputLayout) findViewById(R.id.tilafegirnomassig);
        final TextInputEditText etAddSubjC = (TextInputEditText) findViewById(R.id.etafegirassig);
        etAddSubjC.getText().clear();
        final TextInputEditText etAddSubjN = (TextInputEditText) findViewById(R.id.etafegirnomas);
        etAddSubjN.getText().clear();
        Button btacceptsubj = (Button) findViewById(R.id.btaccepafassig);

        btacceptsubj.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!TextUtils.isEmpty(etAddSubjC.getText()) && !TextUtils.isEmpty(etAddSubjN.getText())) {
                    if (gestormxn.addSubject(etAddSubjC.getText().toString(), etAddSubjN.getText().toString(), contxt)) {
                        Toast toastAE = Toast.makeText(getApplicationContext(), getString(R.string.assignatura_existent), Toast.LENGTH_LONG);
                        toastAE.setGravity(Gravity.CENTER,0,0);
                        toastAE.show();
                    }
                    etAddSubjC.getText().clear();
                    etAddSubjN.getText().clear();
                    Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.insercio_correcta), Toast.LENGTH_LONG);
                    toastIC.setGravity(Gravity.CENTER,0,0);
                    toastIC.show();
                    clearFocus();
                } else {
                    String usuariError = null;
                    if(TextUtils.isEmpty(etAddSubjC.getText())) {
                        usuariError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilAddSubjC, usuariError);

                    String passError = null;
                    if (TextUtils.isEmpty(etAddSubjN.getText())) {
                        passError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilAddSubjN, passError);

                    clearFocus();
                }
            }
        });
    }

    /**
     * Show and active the content to add a new student
     */
    public void activeAddStudent() {
        activeNextView(contentafegirestudiant);
        final TextInputLayout tilAddStudentc = (TextInputLayout) findViewById(R.id.tilafegirestudiantc);
        final TextInputLayout tilAddStudentn = (TextInputLayout) findViewById(R.id.tilafegirestudiantn);
        final TextInputLayout tilAddStudentg = (TextInputLayout) findViewById(R.id.tilafegirestudiantg);
        final TextInputEditText etAddStudentc = (TextInputEditText) findViewById(R.id.etafegirest);
        etAddStudentc.getText().clear();
        final TextInputEditText etAddStudentg = (TextInputEditText) findViewById(R.id.etaddgroupestu);
        etAddStudentg.getText().clear();
        final TextInputEditText etAddStudentn = (TextInputEditText) findViewById(R.id.etaddnomestu);
        etAddStudentn.getText().clear();
        Button btacceptstud = (Button) findViewById(R.id.btaddestudiant);


        btacceptstud.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!etAddStudentc.getText().toString().isEmpty() && !etAddStudentn.getText().toString().isEmpty() && !etAddStudentg.getText().toString().isEmpty()) {
                    gestormxn.addStudent(etAddStudentc.getText().toString(), etAddStudentn.getText().toString(), etAddStudentg.getText().toString(), contxt);
                    etAddStudentc.getText().clear();
                    etAddStudentn.getText().clear();
                    Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.insercio_correcta), Toast.LENGTH_LONG);
                    toastIC.setGravity(Gravity.CENTER,0,0);
                    toastIC.show();
                    clearFocus();
                } else {
                    String studentCError = null;
                    if(TextUtils.isEmpty(etAddStudentc.getText())) {
                        studentCError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilAddStudentc, studentCError);

                    String studentNError = null;
                    if (TextUtils.isEmpty(etAddStudentn.getText())) {
                        studentNError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilAddStudentn, studentNError);

                    String studentGError = null;
                    if (TextUtils.isEmpty(etAddStudentg.getText())) {
                        studentGError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilAddStudentg, studentGError);
                    clearFocus();
                }
            }
        });
    }

    public void activeAddQualification() {
        activeNextView(contentafegirnota);
        final String[] arraySubjects = new String[gestormxn.getSubjects(contxt).size()];
        String[] arrayGroups = new String[gestormxn.getGroups(contxt).size()];
        String[] arrayTypesQ;
        final ArrayList<StudentsMarks> studentsMarks = new ArrayList<>();

        currentStudent = 0;
        ArrayAdapter<CharSequence> aaAssignatures, aaGrups, aaTypesQ;

        for (int i = 0; i < gestormxn.getSubjects(contxt).size(); i++) {
            arraySubjects[i] = gestormxn.getSubjects(contxt).get(i).toString();
        }

        aaAssignatures = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arraySubjects);
        final Spinner spAssignatures = (Spinner) findViewById(R.id.spassignota);
        spAssignatures.setAdapter(aaAssignatures);

        arrayGroups = gestormxn.getGroups(contxt).toArray(arrayGroups);
        Arrays.sort(arrayGroups);
        aaGrups = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayGroups);
        final Spinner spGrups = (Spinner) findViewById(R.id.spgrupnota);
        spGrups.setAdapter(aaGrups);

        arrayTypesQ = getArrayTypes();

        Subject tempSubject = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
        aaTypesQ = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUnusedTypes(arrayTypesQ, tempSubject.getIdSubject(), spGrups.getSelectedItem().toString()));
        final Spinner spTypesQ = (Spinner) findViewById(R.id.sptipusnota);
        spTypesQ.setAdapter(aaTypesQ);

        final TextInputLayout tilPercent = (TextInputLayout) findViewById(R.id.tilafegirnotap);
        final TextInputEditText etPercent = (TextInputEditText) findViewById(R.id.etpercent);
        final Button btPercentMes = (Button) findViewById(R.id.btmes);
        final Button btPercentMenys = (Button) findViewById(R.id.btmenys);

        final TextView tvEstudiantNota = (TextView) findViewById(R.id.tvestudnota);
        final TextInputLayout tilAddNota = (TextInputLayout) findViewById(R.id.tilafegirnota);
        final TextInputEditText etAddNota = (TextInputEditText) findViewById(R.id.etafegirnota);

        final Button btAddNota = (Button) findViewById(R.id.btaddnota);

        final String[][] arrayStudents = {new String[gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size()]};
        for (int i = 0; i < gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size(); i++) {
            arrayStudents[0][i] = gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).get(i).toString();
        }
        tvEstudiantNota.setText(arrayStudents[0][currentStudent]);

        etAddNota.getText().clear();
        etAddNota.setEnabled(false);
        spAssignatures.setEnabled(true);
        spGrups.setEnabled(true);
        spTypesQ.setEnabled(true);
        etPercent.setEnabled(true);
        etPercent.setText(getString(R.string.cent));
        btPercentMes.setEnabled(true);
        btPercentMenys.setEnabled(true);
        btAddNota.setText(getString(R.string.seleccionar));

        spAssignatures.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {

                        String[] arrayTypesQIn = getArrayTypes();
                        ArrayAdapter<CharSequence> aaTypesQIn;
                        Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                        aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUnusedTypes(arrayTypesQIn, tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString()));
                        final Spinner spTypesQ = (Spinner) findViewById(R.id.sptipusnota);
                        spTypesQ.setAdapter(aaTypesQIn);
                        etPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString())));
                        }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });


        spGrups.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {

                        String[] arrayTypesQIn = getArrayTypes();
                        ArrayAdapter<CharSequence> aaTypesQIn;
                        Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                        aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUnusedTypes(arrayTypesQIn, tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString()));
                        final Spinner spTypesQ = (Spinner) findViewById(R.id.sptipusnota);
                        spTypesQ.setAdapter(aaTypesQIn);
                        etPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString())));
                        arrayStudents[0] = new String[gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size()];
                        for (int i = 0; i < gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size(); i++) {
                            arrayStudents[0][i] = gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).get(i).toString();
                        }
                        tvEstudiantNota.setText(arrayStudents[0][currentStudent]);
                    }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });

        etPercent.addTextChangedListener(new TextWatcher() {

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {}

            @Override
            public void afterTextChanged(Editable s) {
                String stPercent = etPercent.getText().toString();

                if(!stPercent.isEmpty()) {
                    int percent = Integer.valueOf(stPercent);
                    Subject tempSubject = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                    if (percent > getMaxValue(tempSubject.getIdSubject(), spGrups.getSelectedItem().toString())) {
                        etPercent.setText(String.valueOf(getMaxValue(tempSubject.getIdSubject(), spGrups.getSelectedItem().toString())));
                    }
                }
            }
        });

        btPercentMes.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                int percentatge = etPercent.getText().toString().isEmpty() ?  0 : Integer.valueOf(etPercent.getText().toString());
                Subject tempSubject = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                if (percentatge < getMaxValue(tempSubject.getIdSubject(), spGrups.getSelectedItem().toString())) {
                    percentatge++;
                    etPercent.setText(Integer.toString(percentatge));
                }
            }
        });

        btPercentMenys.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                int percentatge = etPercent.getText().toString().isEmpty() ? 2 : Integer.valueOf(etPercent.getText().toString());
                if (percentatge > 0) {
                    percentatge--;
                    etPercent.setText(Integer.toString(percentatge));
                }
            }
        });

        btAddNota.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                String botoText = btAddNota.getText().toString();
                if (botoText.equals(getString(R.string.add_next_q))) {
                    String notaError = null;
                    if (TextUtils.isEmpty(etAddNota.getText())) {
                            notaError = getString(R.string.campbuit);
                    } else if(currentStudent == gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size()-2) {//else if(!hasNextStudent()) {
                        studentsMarks.add(new StudentsMarks(tvEstudiantNota.getText().toString(), Float.valueOf(etAddNota.getText().toString())));
                        etAddNota.getText().clear();
                        currentStudent ++;
                        tvEstudiantNota.setText(arrayStudents[0][currentStudent].toString());
                        btAddNota.setText(getString(R.string.finalitzar));

                    } else {
                        studentsMarks.add(new StudentsMarks(tvEstudiantNota.getText().toString(), Float.valueOf(etAddNota.getText().toString())));
                        etAddNota.getText().clear();
                        currentStudent ++;
                        tvEstudiantNota.setText(arrayStudents[0][currentStudent].toString());
                    }
                    toggleTextInputLayoutError(tilAddNota, notaError);

                } else if(botoText.equals(getString(R.string.finalitzar))) {
                    String notaError = null;
                    if (TextUtils.isEmpty(etAddNota.getText())) {
                        notaError = getString(R.string.campbuit);
                    } else {
                        studentsMarks.add(new StudentsMarks(tvEstudiantNota.getText().toString(), Float.valueOf(etAddNota.getText().toString())));
                        Subject tempSubject = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                        gestormxn.addTypePercentQual(tempSubject.getIdSubject(), spGrups.getSelectedItem().toString(), spTypesQ.getSelectedItem().toString(), etPercent.getText().toString(), contxt);
                        gestormxn.addQualifications(tempSubject.getIdSubject(), spGrups.getSelectedItem().toString(), spTypesQ.getSelectedItem().toString(), studentsMarks, contxt);
                        studentsMarks.clear();
                        etAddNota.getText().clear();
                        etAddNota.setEnabled(false);
                        spAssignatures.setEnabled(true);
                        spGrups.setEnabled(true);
                        spTypesQ.setEnabled(true);

                        String[] arrayTypesQIn = getArrayTypes();
                        ArrayAdapter<CharSequence> aaTypesQIn;
                        Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spAssignatures.getSelectedItemPosition());
                        aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUnusedTypes(arrayTypesQIn, tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString()));
                        final Spinner spTypesQ = (Spinner) findViewById(R.id.sptipusnota);
                        spTypesQ.setAdapter(aaTypesQIn);

                        etPercent.setEnabled(true);
                        etPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spGrups.getSelectedItem().toString())));
                        btPercentMes.setEnabled(true);
                        btPercentMenys.setEnabled(true);
                        currentStudent = 0;
                        tvEstudiantNota.setText(arrayStudents[0][currentStudent].toString());
                        btAddNota.setText(getString(R.string.seleccionar));

                        Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.insercio_correcta), Toast.LENGTH_LONG);
                        toastIC.setGravity(Gravity.CENTER, 0, 0);
                        toastIC.show();
                        clearFocus();
                    }
                    toggleTextInputLayoutError(tilAddNota, notaError);
                } else if ((!TextUtils.isEmpty(etPercent.getText())) || !(Integer.valueOf(etPercent.getText().toString()) == 0)) {

                    etAddNota.setEnabled(true);
                    spAssignatures.setEnabled(false);
                    spGrups.setEnabled(false);
                    spTypesQ.setEnabled(false);
                    etPercent.setEnabled(false);
                    btPercentMes.setEnabled(false);
                    btPercentMenys.setEnabled(false);
                    btAddNota.setText(getString(R.string.add_next_q));

                    if (gestormxn.getStudents(spGrups.getSelectedItem().toString(), contxt).size()-2 == -1) {
                        btAddNota.setText(getString(R.string.finalitzar));
                    }

                } else {
                    toggleTextInputLayoutError(tilPercent, getString(R.string.campbuit));
                }
            }
        });
    }

    /**
     * Show and active the content to show qualifications
     */
    public void activeShowQualification() {
        activeNextView(contentmostrarnotes);

        String[] arrayShowSubjects = new String[gestormxn.getSubjects(contxt).size()];
        String[] arrayShowGroups = new String[gestormxn.getGroups(contxt).size()];

        final ArrayAdapter<CharSequence> aaShowSubjects, aaShowGroups;

        for (int i = 0; i < gestormxn.getSubjects(contxt).size(); i++) {
            arrayShowSubjects[i] = gestormxn.getSubjects(contxt).get(i).toString();
        }

        aaShowSubjects = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayShowSubjects);
        final Spinner spShowSubjects = (Spinner) findViewById(R.id.spshowsubject);
        spShowSubjects.setAdapter(aaShowSubjects);

        arrayShowGroups = gestormxn.getGroups(contxt).toArray(arrayShowGroups);
        Arrays.sort(arrayShowGroups);
        aaShowGroups = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayShowGroups);
        final Spinner spShowGrups = (Spinner) findViewById(R.id.spshowgroup);
        spShowGrups.setAdapter(aaShowGroups);

        ArrayAdapter<CharSequence> aaShowQ;
        final ListView lvShowQ = (ListView) findViewById(R.id.lvshownotes);
        String[] arrayShowElements = new String[0];
        arrayShowElements = getShowElements(gestormxn.getSubjects(contxt).get(spShowSubjects.getSelectedItemPosition()).getIdSubject(), spShowGrups.getSelectedItem().toString()).toArray(arrayShowElements);
        aaShowQ = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayShowElements);
        lvShowQ.setAdapter(aaShowQ);

        spShowSubjects.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        ArrayAdapter<CharSequence> aaShowQ;
                        String[] arrayShowElements = new String[0];
                        arrayShowElements = getShowElements(gestormxn.getSubjects(contxt).get(spShowSubjects.getSelectedItemPosition()).getIdSubject(), spShowGrups.getSelectedItem().toString()).toArray(arrayShowElements);
                        aaShowQ = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayShowElements);
                        lvShowQ.setAdapter(aaShowQ);
                    }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });

        spShowGrups.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        ArrayAdapter<CharSequence> aaShowQ;
                        String[] arrayShowElements = new String[0];
                        arrayShowElements = getShowElements(gestormxn.getSubjects(contxt).get(spShowSubjects.getSelectedItemPosition()).getIdSubject(), spShowGrups.getSelectedItem().toString()).toArray(arrayShowElements);
                        aaShowQ = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayShowElements);
                        lvShowQ.setAdapter(aaShowQ);
                    }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });
    }

    /**
     * Show and active the content to modify the students
     */
    public void activeModStudent(){
        activeNextView(contentmodest);
        final TextInputLayout tilModStuN = (TextInputLayout) findViewById(R.id.tilmodestudiantn);
        final TextInputEditText etModStuN = (TextInputEditText) findViewById(R.id.etmodnomestu);
        Button btModStu = (Button) findViewById(R.id.btmodestudiant);
        final ArrayList<Student> students = new ArrayList<>();

        final ArrayAdapter<CharSequence> aaModStuName, aaModStuGroups;

        String[] arrayModStuGroups = new String[gestormxn.getGroups(contxt).size()];
        arrayModStuGroups = gestormxn.getGroups(contxt).toArray(arrayModStuGroups);
        Arrays.sort(arrayModStuGroups);
        aaModStuGroups = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModStuGroups);
        final Spinner spModGroupStu = (Spinner) findViewById(R.id.spmodgroupestu);
        spModGroupStu.setAdapter(aaModStuGroups);

        students.clear();
        students.addAll(gestormxn.getStudents(spModGroupStu.getSelectedItem().toString(), contxt));
        String[] arrayModStuNames = new String[students.size()];
        for (int i = 0; i < students.size(); i++) {
            arrayModStuNames[i] = gestormxn.getStudents(spModGroupStu.getSelectedItem().toString(), contxt).get(i).getIdStudent();
        }
        aaModStuName = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModStuNames);
        final Spinner spModCodeStu = (Spinner) findViewById(R.id.spmodcodestu);
        spModCodeStu.setAdapter(aaModStuName);

        etModStuN.setText(students.get(spModCodeStu.getSelectedItemPosition()).getNameStudent());

        spModGroupStu.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        ArrayAdapter<CharSequence> aaModStuNameIn;

                        students.clear();
                        students.addAll(gestormxn.getStudents(spModGroupStu.getSelectedItem().toString(), contxt));
                        String[] arrayModStuNames = new String[students.size()];
                        for (int i = 0; i < students.size(); i++) {
                            arrayModStuNames[i] = gestormxn.getStudents(spModGroupStu.getSelectedItem().toString(), contxt).get(i).getIdStudent();
                        }
                        aaModStuNameIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModStuNames);
                        spModCodeStu.setAdapter(aaModStuNameIn);
                    }
                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });

        spModCodeStu.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        etModStuN.setText(students.get(spModCodeStu.getSelectedItemPosition()).getNameStudent());
                    }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });

        btModStu.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(!etModStuN.getText().toString().equals(students.get(spModCodeStu.getSelectedItemPosition()).toString()) || !etModStuN.getText().toString().isEmpty() ) {
                    Student student = new Student(spModCodeStu.getSelectedItem().toString(), etModStuN.getText().toString());
                    students.set(spModCodeStu.getSelectedItemPosition(), student);
                    gestormxn.modifyStudent(spModGroupStu.getSelectedItem().toString(), students, contxt);
                    Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.modificacio_correcta), Toast.LENGTH_LONG);
                    toastIC.setGravity(Gravity.CENTER, 0, 0);
                    toastIC.show();
                    clearFocus();
                } else {
                    String passError = null;
                    if (TextUtils.isEmpty(etModStuN.getText())) {
                        passError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilModStuN, passError);

                    passError = null;
                    if (!etModStuN.getText().toString().equals(students.get(spModCodeStu.getSelectedItemPosition()).toString())) {
                        passError = getString(R.string.error_camp_igual);
                    }
                    toggleTextInputLayoutError(tilModStuN, passError);
                    clearFocus();
                }
            }
        });
    }

    /**
     * Show and active the content to modify the subjects
     */
    public void activeModSubject() {
        activeNextView(contentmodassig);
        final TextInputLayout tilModNameSubj = (TextInputLayout) findViewById(R.id.tilmodnomassig);
        final TextInputEditText etModNameSubj = (TextInputEditText) findViewById(R.id.etmodnomas);
        Button btModSubj = (Button) findViewById(R.id.btaccepmodassig);

        String[] arrayModSubjects = new String[gestormxn.getSubjects(contxt).size()];
        Log.i("subject-get", "size: " + gestormxn.getSubjects(contxt).size());
        final ArrayAdapter<CharSequence> aaModSubjects;
        final ArrayList<Subject> subjects = gestormxn.getSubjects(contxt);
        Log.i("subject-AL", "size: " + subjects.size());

        for (int i = 0; i < subjects.size(); i++) {
            arrayModSubjects[i] = subjects.get(i).getIdSubject();
        }

        aaModSubjects = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModSubjects);
        final Spinner spModSubjects = (Spinner) findViewById(R.id.spmodassig);
        spModSubjects.setAdapter(aaModSubjects);

        etModNameSubj.setText(subjects.get(spModSubjects.getSelectedItemPosition()).getNameSubject());

        spModSubjects.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        etModNameSubj.setText(subjects.get(spModSubjects.getSelectedItemPosition()).getNameSubject());
                    }

                    public void onNothingSelected(AdapterView<?> parent) {

                    }
                });

        btModSubj.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(!etModNameSubj.getText().toString().equals(subjects.get(spModSubjects.getSelectedItemPosition()).getNameSubject())
                || !etModNameSubj.getText().toString().isEmpty())  {
                    Subject subject = new Subject(spModSubjects.getSelectedItem().toString(), etModNameSubj.getText().toString());
                    subjects.set(spModSubjects.getSelectedItemPosition(), subject);
                    gestormxn.modifySubject(subjects, contxt);
                    Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.modificacio_correcta), Toast.LENGTH_LONG);
                    toastIC.setGravity(Gravity.CENTER, 0, 0);
                    toastIC.show();
                    clearFocus();
                } else {
                    String passError = null;
                    if (TextUtils.isEmpty(etModNameSubj.getText())) {
                        passError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilModNameSubj, passError);

                    passError = null;
                    if (!etModNameSubj.getText().toString().equals(gestormxn.getSubjects(contxt).get(spModSubjects.getSelectedItemPosition()).getNameSubject())) {
                        passError = getString(R.string.error_camp_igual);
                    }
                    toggleTextInputLayoutError(tilModNameSubj, passError);
                    clearFocus();
                }
            }
        });
    }

    /**
     * Show and active the content to modify the qualifications and to modify the evaluations methods
     */
    public void activeModQual(boolean isQual) {
        activeNextView(contentmodnota);
        final Spinner spModAssignatures = (Spinner) findViewById(R.id.spmodassignota);
        final Spinner spModGrups = (Spinner) findViewById(R.id.spmodgrupnota);
        final Spinner spModTypesQ = (Spinner) findViewById(R.id.spmodtipusnota);
        final Button btModPercentMenys = (Button) findViewById(R.id.btmodmenys);
        final TextInputLayout tilModPercent = (TextInputLayout) findViewById(R.id.tilmodnotap);
        final TextInputEditText etModPercent = (TextInputEditText) findViewById(R.id.etmodpercent);
        final Button btModPercentMes = (Button) findViewById(R.id.btmodmes);
        final TextView tvModTitolEstud = (TextView) findViewById(R.id.tvmodtitolestu);
        final TextView tvModEstudiantNota = (TextView) findViewById(R.id.tvmodestudnota);
        final TextInputLayout tilModAddNota = (TextInputLayout) findViewById(R.id.tilmodnota);
        final TextInputEditText etModAddNota = (TextInputEditText) findViewById(R.id.etmodnota);
        final Button btModAddNota = (Button) findViewById(R.id.btmodnota);

        final String[] arrayModSubjects = new String[gestormxn.getSubjects(contxt).size()];
        String[] arrayModGroups = new String[gestormxn.getGroups(contxt).size()];
        final ArrayList<StudentsMarks> studentsModMarks = new ArrayList<>();

        ArrayAdapter<CharSequence> aaModAssignatures, aaModGrups, aaModTypesQ;

        for (int i = 0; i < gestormxn.getSubjects(contxt).size(); i++) {
            arrayModSubjects[i] = gestormxn.getSubjects(contxt).get(i).toString();
        }
        aaModAssignatures = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModSubjects);
        spModAssignatures.setAdapter(aaModAssignatures);


        arrayModGroups = gestormxn.getGroups(contxt).toArray(arrayModGroups);
        Arrays.sort(arrayModGroups);
        aaModGrups = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, arrayModGroups);
        spModGrups.setAdapter(aaModGrups);

        final Subject tempModSubject = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
        aaModTypesQ = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUsedTypes(tempModSubject.getIdSubject(), spModGrups.getSelectedItem().toString()));
        spModTypesQ.setAdapter(aaModTypesQ);

        currentStudent = 0;
        final String[][] arrayModStudents = {new String[gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size()]};
        for (int i = 0; i < gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size(); i++) {
            arrayModStudents[0][i] = gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).get(i).toString();
        }
        tvModEstudiantNota.setText(arrayModStudents[0][currentStudent]);

        if(isQual) {
            btModPercentMenys.setVisibility(Button.INVISIBLE);
            tilModPercent.setVisibility(TextInputLayout.INVISIBLE);
            etModPercent.setVisibility(EditText.INVISIBLE);
            btModPercentMes.setVisibility(Button.INVISIBLE);
            tvModTitolEstud.setVisibility(TextView.VISIBLE);
            tvModEstudiantNota.setVisibility(TextView.VISIBLE);
            tilModAddNota.setVisibility(TextInputLayout.VISIBLE);
            etModAddNota.setVisibility(EditText.VISIBLE);

            btModAddNota.setText(R.string.seleccionar);

            etModAddNota.setEnabled(false);

            btModAddNota.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                    String botoText = btModAddNota.getText().toString();
                    if (botoText.equals(getString(R.string.add_next_q))) {
                        String notaError = null;
                        if (TextUtils.isEmpty(etModAddNota.getText())) {
                            notaError = getString(R.string.campbuit);
                        } else if(currentStudent == gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size()-2) {//else if(!hasNextStudent()) {
                            studentsModMarks.add(new StudentsMarks(tvModEstudiantNota.getText().toString(), Float.valueOf(etModAddNota.getText().toString())));
                            etModAddNota.getText().clear();
                            currentStudent ++;
                            tvModEstudiantNota.setText(arrayModStudents[0][currentStudent].toString());
                            btModAddNota.setText(getString(R.string.finalitzar));

                        } else {
                            studentsModMarks.add(new StudentsMarks(tvModEstudiantNota.getText().toString(), Float.valueOf(etModAddNota.getText().toString())));
                            etModAddNota.getText().clear();
                            currentStudent ++;
                            tvModEstudiantNota.setText(arrayModStudents[0][currentStudent].toString());
                        }
                        toggleTextInputLayoutError(tilModAddNota, notaError);

                    } else if(botoText.equals(getString(R.string.finalitzar))) {
                        String notaError = null;
                        if (TextUtils.isEmpty(etModAddNota.getText())) {
                            notaError = getString(R.string.campbuit);
                        } else {
                            studentsModMarks.add(new StudentsMarks(tvModEstudiantNota.getText().toString(), Float.valueOf(etModAddNota.getText().toString())));
                            Subject tempSubject = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                            gestormxn.addQualifications(tempSubject.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString(), studentsModMarks, contxt);
                            studentsModMarks.clear();
                            etModAddNota.getText().clear();
                            etModAddNota.setEnabled(false);
                            spModAssignatures.setEnabled(true);
                            spModGrups.setEnabled(true);
                            spModTypesQ.setEnabled(true);

                            String[] arrayTypesQIn = getArrayTypes();
                            ArrayAdapter<CharSequence> aaTypesQIn;
                            Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                            aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUnusedTypes(arrayTypesQIn, tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString()));
                            final Spinner spTypesQ = (Spinner) findViewById(R.id.sptipusnota);
                            spTypesQ.setAdapter(aaTypesQIn);

                            etModPercent.setEnabled(true);
                            etModPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString())));
                            btModPercentMes.setEnabled(true);
                            btModPercentMenys.setEnabled(true);
                            currentStudent = 0;
                            tvModEstudiantNota.setText(arrayModStudents[0][currentStudent].toString());
                            btModAddNota.setText(getString(R.string.seleccionar));

                            Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.insercio_correcta), Toast.LENGTH_LONG);
                            toastIC.setGravity(Gravity.CENTER, 0, 0);
                            toastIC.show();
                            clearFocus();
                        }
                        toggleTextInputLayoutError(tilModAddNota, notaError);
                    } else if ((!TextUtils.isEmpty(etModPercent.getText())) || !(Integer.valueOf(etModPercent.getText().toString()) == 0)) {

                        etModAddNota.setEnabled(true);
                        spModAssignatures.setEnabled(false);
                        spModGrups.setEnabled(false);
                        spModTypesQ.setEnabled(false);
                        etModPercent.setEnabled(false);
                        btModPercentMes.setEnabled(false);
                        btModPercentMenys.setEnabled(false);
                        btModAddNota.setText(getString(R.string.add_next_q));

                        if (gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size()-2 == -1) {
                            btModAddNota.setText(getString(R.string.finalitzar));
                        }

                    } else {
                        toggleTextInputLayoutError(tilModPercent, getString(R.string.campbuit));
                    }
                }
            });

        } else {

            btModPercentMenys.setVisibility(Button.VISIBLE);
            tilModPercent.setVisibility(TextInputLayout.VISIBLE);
            etModPercent.setVisibility(EditText.VISIBLE);
            btModPercentMes.setVisibility(Button.VISIBLE);
            tvModTitolEstud.setVisibility(TextView.INVISIBLE);
            tvModEstudiantNota.setVisibility(TextView.INVISIBLE);
            tilModAddNota.setVisibility(TextInputLayout.INVISIBLE);
            etModAddNota.setVisibility(EditText.INVISIBLE);

            btModAddNota.setText(R.string.acceptar);

            spModAssignatures.setOnItemSelectedListener(
                    new AdapterView.OnItemSelectedListener() {
                        public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {

                            ArrayAdapter<CharSequence> aaTypesQIn;
                            Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                            aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUsedTypes(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString()));
                            spModTypesQ.setAdapter(aaTypesQIn);
                            etModPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())));
                        }

                        public void onNothingSelected(AdapterView<?> parent) {

                        }
                    });

            spModTypesQ.setOnItemSelectedListener(
                    new AdapterView.OnItemSelectedListener() {
                        public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {

                            Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                            etModPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())));
                        }

                        public void onNothingSelected(AdapterView<?> parent) {

                        }
                    });


            etModPercent.addTextChangedListener(new TextWatcher() {

                @Override
                public void beforeTextChanged(CharSequence s, int start, int count, int after) {}

                @Override
                public void onTextChanged(CharSequence s, int start, int before, int count) {}

                @Override
                public void afterTextChanged(Editable s) {
                    String stModPercent = etModPercent.getText().toString();

                    if(!stModPercent.isEmpty()) {
                        int percent = Integer.valueOf(stModPercent);
                        if (percent > getMaxValue(tempModSubject.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())) {
                            etModPercent.setText(String.valueOf(getMaxValue(tempModSubject.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())));
                        }
                    }
                }
            });

            btModPercentMes.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    int percentatge = etModPercent.getText().toString().isEmpty() ?  0 : Integer.valueOf(etModPercent.getText().toString());
                    if (percentatge < getMaxValue(tempModSubject.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())) {
                        percentatge++;
                        etModPercent.setText(Integer.toString(percentatge));
                    }
                }
            });

            btModPercentMenys.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                    int percentatge = etModPercent.getText().toString().isEmpty() ? 2 : Integer.valueOf(etModPercent.getText().toString());
                    if (percentatge > 0) {
                        percentatge--;
                        etModPercent.setText(Integer.toString(percentatge));
                    }
                }
            });

            btModAddNota.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    if(!TextUtils.isEmpty(etModPercent.getText()) || Integer.valueOf(etModPercent.getText().toString()) == 0) {
                        Subject tempModSubjectIn = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                        //gestormxn.getStudentsMarks(tempModSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString(), contxt);
                        gestormxn.modifyTypePercentQual(tempModSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString(), etModPercent.getText().toString(), contxt);
                        etModPercent.setText(String.valueOf(getMaxValue(tempModSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())));

                        Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.insercio_correcta), Toast.LENGTH_LONG);
                        toastIC.setGravity(Gravity.CENTER, 0, 0);
                        toastIC.show();
                        clearFocus();
                    } else {

                        toggleTextInputLayoutError(tilModPercent, getString(R.string.campbuit));

                    }
                }
            });
        }

        spModGrups.setOnItemSelectedListener(
                new AdapterView.OnItemSelectedListener() {
                    public void onItemSelected(AdapterView<?> parent, View view, int pos, long id) {
                        ArrayAdapter<CharSequence> aaTypesQIn;
                        Subject tempSubjectIn = gestormxn.getSubjects(contxt).get(spModAssignatures.getSelectedItemPosition());
                        aaTypesQIn = new ArrayAdapter<CharSequence>(contxt, android.R.layout.simple_list_item_1, getUsedTypes(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString()));
                        spModTypesQ.setAdapter(aaTypesQIn);
                        etModPercent.setText(String.valueOf(getMaxValue(tempSubjectIn.getIdSubject(), spModGrups.getSelectedItem().toString(), spModTypesQ.getSelectedItem().toString())));

                        currentStudent = 0;
                        final String[][] arrayModStudents = {new String[gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size()]};
                        for (int i = 0; i < gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).size(); i++) {
                            arrayModStudents[0][i] = gestormxn.getStudents(spModGrups.getSelectedItem().toString(), contxt).get(i).toString();
                        }
                        tvModEstudiantNota.setText(arrayModStudents[0][currentStudent]);
                    }

                        public void onNothingSelected(AdapterView<?> parent) {

                        }
                    });
    }

    /**
     * Show and active the content to add a new evaluation method
     */
    public void activeAddType() {
        activeNextView(contentafegirtipus);
        final TextInputLayout tilNewType = (TextInputLayout) findViewById(R.id.tilconfnoutipus);
        final TextInputEditText etNewType = (TextInputEditText) findViewById(R.id.etconfnoutipus);
        etNewType.getText().clear();
        final Button btNewType = (Button) findViewById(R.id.btafegirtipus);

        btNewType.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                if (!TextUtils.isEmpty(etNewType.getText())) {
                    if(!gestormxn.addTypeQualification(etNewType.getText().toString(), contxt)) {
                        etNewType.getText().clear();
                        Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.modificacio_correcta), Toast.LENGTH_LONG);
                        toastIC.setGravity(Gravity.CENTER, 0, 0);
                        toastIC.show();
                        clearFocus();
                    } else {
                        Toast toastAE = Toast.makeText(getApplicationContext(), getString(R.string.tipus_existent), Toast.LENGTH_LONG);
                        toastAE.setGravity(Gravity.CENTER,0,0);
                        etNewType.getText().clear();
                        toastAE.show();
                    }

                } else {
                    String newTypeError = null;
                    if (TextUtils.isEmpty(etNewType.getText())) {
                        newTypeError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilNewType, newTypeError);
                    clearFocus();
                }
            }
        });
    }

    /**
     * Show and active the content to edit the password
     */
    public void activeEditConfig() {
        activeNextView(contentconfig);

        final TextInputLayout tilOldPwd = (TextInputLayout) findViewById(R.id.tilconfoldpwd);
        final TextInputLayout tilNewPwd = (TextInputLayout) findViewById(R.id.tilconfnewpwd);
        final TextInputEditText etOldPwd = (TextInputEditText) findViewById(R.id.etconfoldpwd);
        etOldPwd.getText().clear();
        final TextInputEditText etNewPwd = (TextInputEditText) findViewById(R.id.etconfnewpwd);
        etNewPwd.getText().clear();
        final Button btNewPwd = (Button) findViewById(R.id.btaccepafpwd);


        btNewPwd.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                // check if fields are not empty
                if (!TextUtils.isEmpty(etOldPwd.getText()) && !TextUtils.isEmpty(etNewPwd.getText())) {
                    SharedPreferences spAcces = getSharedPreferences("dadesacces", contxt.MODE_PRIVATE);

                    final String contrasenya = spAcces.getString("contrasenya", "NULL");

                    // check if new value is not the same
                    if(etOldPwd.getText().toString().equals(etNewPwd.getText().toString())) {
                        etOldPwd.getText().clear();
                        etNewPwd.getText().clear();
                        String pwdEqualsError = getString(R.string.error_contrasenyes_iguals);
                        toggleTextInputLayoutError(tilOldPwd, pwdEqualsError);
                        toggleTextInputLayoutError(tilNewPwd, pwdEqualsError);
                        clearFocus();
                    }else
                    // check if old password is equal to current password
                    if(contrasenya.equals(etOldPwd.getText().toString())) {
                        final SharedPreferences finalSpAcces = spAcces;

                        SharedPreferences.Editor edituser = finalSpAcces.edit();
                        edituser.putString("contrasenya", etNewPwd.getText().toString());
                        edituser.commit();

                        etOldPwd.getText().clear();
                        etNewPwd.getText().clear();
                        Toast toastIC = Toast.makeText(getApplicationContext(), getString(R.string.modificacio_correcta), Toast.LENGTH_LONG);
                        toastIC.setGravity(Gravity.CENTER,0,0);
                        toastIC.show();
                        clearFocus();
                    } else {
                        etOldPwd.getText().clear();
                        etNewPwd.getText().clear();
                        String pwdEqualError = getString(R.string.error_contrasenya_actual);
                        toggleTextInputLayoutError(tilOldPwd, pwdEqualError);
                        clearFocus();
                    }
                } else {
                    String oldPwdError = null;
                    if(TextUtils.isEmpty(etOldPwd.getText())) {
                        oldPwdError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilOldPwd, oldPwdError);

                    String newPwdError = null;
                    if (TextUtils.isEmpty(etNewPwd.getText())) {
                        newPwdError = getString(R.string.campbuit);
                    }
                    toggleTextInputLayoutError(tilNewPwd, newPwdError);
                    clearFocus();
                }
            }
        });
    }

    /**
     * Function to format the information to show
     */
    public ArrayList<String> getShowElements(String idSubject, String group) {
        ArrayList<String> showElements = new ArrayList<>();
        ArrayList<TotalMarkFormat> totalMarkFormats = new ArrayList<>();
        ArrayList<StudentsMarks> studentsMarks;
        ArrayList<Student> students = gestormxn.getStudents(group, contxt);
        TotalMarkFormat total;
        int i;
        boolean changed;
        String element;

        for (TypePercentQual typePercentQual : gestormxn.getTypePercentQual(idSubject, group, contxt)) {
            i = 0;
            changed = false;
            studentsMarks = gestormxn.getStudentsMarks(idSubject, group, typePercentQual.getTypeQual(), contxt);
            for (StudentsMarks studentMark : studentsMarks) {
                if(!studentMark.getStudent().equals(students.get(i).toString())) {
                    studentMark.setStudent(students.get(i).toString());
                    studentsMarks.set(i, studentMark);
                    changed = true;
                }
                if(showElements.size() < gestormxn.getStudentsMarks(idSubject, group, typePercentQual.getTypeQual(), contxt).size()) {
                    element = studentMark.getStudent() + "\n\t" + typePercentQual.getTypeQual() + "(" + typePercentQual.getPercentQual() +
                            "%): " + String.valueOf(studentMark.getMark() * typePercentQual.getPercentQual() / 100);
                    showElements.add(element);
                    total = new TotalMarkFormat(typePercentQual.getPercentQual(), studentMark.getMark() * typePercentQual.getPercentQual() / 100);
                    totalMarkFormats.add(total);
                    i++;
                } else {
                    element = showElements.get(i) + "\n\t" + typePercentQual.getTypeQual() + "(" + typePercentQual.getPercentQual() +
                            "%): " + String.valueOf(studentMark.getMark() * typePercentQual.getPercentQual() / 100);
                    showElements.set(i, element);
                    total = new TotalMarkFormat(totalMarkFormats.get(i).getTotalPercent() + typePercentQual.getPercentQual(),
                            totalMarkFormats.get(i).getTotalMark() + studentMark.getMark() * typePercentQual.getPercentQual() / 100);
                    totalMarkFormats.set(i, total);
                    i++;
                }
            }
            if (changed) {
                gestormxn.addQualifications(idSubject, group, typePercentQual.getTypeQual(), studentsMarks, contxt);
            }
        }

        for(int e = 0; e < showElements.size(); e++) {
            showElements.set(e, showElements.get(e) + "\n\t" + getString(R.string.total) + "(" +
                    totalMarkFormats.get(e).getTotalPercent() + "%): " + totalMarkFormats.get(e).getTotalMark());
        }

        return showElements;
    }

    /**
     * Function to get the qualification methods unused on a subject and group
     */
    public String[] getUnusedTypes(String[] arrayTypes, String idSubject, String group) {
        String[] arrayUnusedTypes = new String[arrayTypes.length - gestormxn.getTypePercentQual(idSubject, group, contxt).size()];
        int j = 0;
        boolean trobat;
        if (!idSubject.equals("") || !group.equals("")) {
            for (int i = 0; i < arrayTypes.length; i++) {
                trobat = false;
                for (TypePercentQual typePercentQual : gestormxn.getTypePercentQual(idSubject, group, contxt)) {
                    if (typePercentQual.getTypeQual().equals(arrayTypes[i])) {
                        trobat = true;
                    }
                }
                if (!trobat) {
                    arrayUnusedTypes[j] = arrayTypes[i];
                    j++;
                }
            }
        } else {
            arrayUnusedTypes = arrayTypes;
        }
        return arrayUnusedTypes;
    }

    /**
     * Function to get the qualification methods used on a subject and group
     */
    public String[] getUsedTypes(String subject, String group) {
        String[] arrayUsedTypes = new String[gestormxn.getTypePercentQual(subject, group, contxt).size()];
        int pos = 0;
        for (TypePercentQual typePercentQual : gestormxn.getTypePercentQual(subject, group, contxt)) {
            arrayUsedTypes[pos] = typePercentQual.getTypeQual();
            pos ++;
        }
        return arrayUsedTypes;
    }

    /**
     * Function to get the max percentage avaible for a subject and group
     */
    public int getMaxValue(String idSubject, String group) {
        int value = 100;
            for (TypePercentQual typePercentQual : gestormxn.getTypePercentQual(idSubject, group, contxt)) {
                value = value - typePercentQual.getPercentQual();
        }
        return value;
    }

    /**
     * Function to get the max percentage avaible to modify a subject, group and qualification method
     */
    public int getMaxValue(String idSubject, String group, String typeQual) {
        int value = 100;
        for (TypePercentQual typePercentQual : gestormxn.getTypePercentQual(idSubject, group, contxt)) {
            if (!typePercentQual.getTypeQual().equals(typeQual)) {
                value = value - typePercentQual.getPercentQual();
            }
        }
        return value;
    }

    /**
     * Function to get all qualification methods (default and user methods)
     * @return
     */
    public String[] getArrayTypes() {

        String[] arrayTmp = new String[getResources().getStringArray(R.array.tipus_q).length + gestormxn.getUserTypes(contxt).size()];

        for(int i = 0; i < getResources().getStringArray(R.array.tipus_q).length; i++) {
            arrayTmp[i] = getResources().getStringArray(R.array.tipus_q)[i];
        }
        for(int k = getResources().getStringArray(R.array.tipus_q).length; k < arrayTmp.length; k++) {
            arrayTmp[k] = gestormxn.getUserTypes(contxt).get(k - getResources().getStringArray(R.array.tipus_q).length);
        }
        return arrayTmp;
    }

    /**
     * Display/hides TextInputLayout error.
     *
     * @param msg the message, or null to hide
     */
    private static void toggleTextInputLayoutError(@NonNull TextInputLayout textInputLayout,
                                                   String msg) {
        textInputLayout.setError(msg);
        if (msg == null) {
            textInputLayout.setErrorEnabled(false);
        } else {
            textInputLayout.setErrorEnabled(true);
        }
    }

    private void clearFocus() {
        View view = this.getCurrentFocus();
        if (view != null && view instanceof EditText) {
            InputMethodManager inputMethodManager = (InputMethodManager) getSystemService(Context
                    .INPUT_METHOD_SERVICE);
            inputMethodManager.hideSoftInputFromWindow(view.getWindowToken(), 0);
            view.clearFocus();
        }
    }
}
