package insistesoft.multixnotes;

import android.content.Context;
import android.support.v7.app.AppCompatActivity;

import java.util.ArrayList;

import insistesoft.multixnotes.beans.Student;
import insistesoft.multixnotes.beans.StudentsMarks;
import insistesoft.multixnotes.beans.Subject;
import insistesoft.multixnotes.beans.TypePercentQual;
import insistesoft.multixnotes.tools.FilesName;


public class GestorMxNImplement extends AppCompatActivity implements GestorMxNInterface {

    //Data manager
    GestorDades gestordades = new GestorDades();

    public boolean addSubject(String idSubject, String nameSubject, Context ctx) {

        //Create new Subject
        Subject newSubject = new Subject(idSubject, nameSubject);
        boolean isSubject = false;

        if(gestordades.checkFile(FilesName.FILESUBJECTS, ctx)) {
            //Check if this subject exists
            if (!getSubjects(ctx).contains(newSubject)) {
                // set new subject to file
                gestordades.setSubjectsFile(newSubject, ctx);
            } else isSubject = true;
        } else {
            // set new subject to file
            gestordades.setSubjectsFile(newSubject, ctx);
        }
        return isSubject;
    }


    public boolean addStudent(String idStudent, String nameStudent, String group, Context ctx) {

        //Create new student
        Student newStudent = new Student(idStudent, nameStudent);
        boolean isStudent = false;

        //Check if this group exists
        if(!gestordades.checkFile(FilesName.FILEGROUPS, ctx)) {
            gestordades.setGroupsFile(group, ctx);
            gestordades.setStudentsFile(group, newStudent, ctx);
        } else {
            if (!gestordades.getGroupsFile(ctx).contains(group)) {
                gestordades.setGroupsFile(group, ctx);
                gestordades.setStudentsFile(group, newStudent, ctx);
            } else {
                if (!gestordades.getStudentsFile(group, ctx).contains(newStudent)) {
                    gestordades.setStudentsFile(group, newStudent, ctx);
                } else {
                    isStudent = true;
                }
            }
        }
        return isStudent;
    }

    public boolean addTypeQualification(String nameQual, Context ctx) {

        boolean isType = false;

        if(gestordades.checkFile(FilesName.FILEUSERTYPES, ctx)) {
            if(gestordades.getUserTypesFile(ctx).contains(nameQual)) {
                isType = true;
            } else {
                gestordades.setUserTypesFile(nameQual, ctx);
            }
        } else {
            gestordades.setUserTypesFile(nameQual, ctx);
        }
        return isType;
    }

    public void addQualifications(String subject, String group, String typeQ, ArrayList<StudentsMarks> studentsMarks, Context ctx) {
        gestordades.setStudentsMarksFile(subject, group, typeQ, studentsMarks, ctx);
    }

    public void addTypePercentQual(String subject, String group, String type, String percent, Context ctx) {
        TypePercentQual typePercentQual = new TypePercentQual(type, Integer.valueOf(percent));
        gestordades.setTypePercentQualFile(subject, group, typePercentQual, ctx);
    }

    public void addUserType(String userType, Context ctx) {
        gestordades.setUserTypesFile(userType, ctx);
    }

    //Modify Functions

    public void modifyStudent(String group, ArrayList<Student> student, Context ctx) {
        gestordades.setStudentsFile(group, student, ctx);
    }

    public void modifySubject(ArrayList<Subject> subjects, Context ctx) {
        gestordades.setSubjectsFile(subjects, ctx);
    }

    public void modifyTypePercentQual(String idSubject, String group, String type, String percent, Context ctx) {
        gestordades.setTypePercentQualFile(idSubject, group, type, percent, ctx);
    }

    // Getters

    @Override
    public ArrayList<Subject> getSubjects(Context ctx) {
        return gestordades.getSubjectsFile(ctx);
    }

    public ArrayList<String> getGroups(Context ctx) {
        return gestordades.getGroupsFile(ctx);
    }

    public ArrayList<Student> getStudents(String group, Context ctx) {
        return gestordades.getStudentsFile(group, ctx);
    }

    public ArrayList<StudentsMarks> getStudentsMarks(String subject, String group, String typeQ, Context ctx) {
        return gestordades.getStudentsMarksFile(subject, group, typeQ, ctx);
    }

    public ArrayList<TypePercentQual> getTypePercentQual(String subject, String group, Context ctx) {
        return gestordades.getTypeQualFile(subject, group, ctx);
    }

    public ArrayList<String> getUserTypes(Context ctx) {
        if(gestordades.checkFile(FilesName.FILEUSERTYPES, ctx)) {
            return gestordades.getUserTypesFile(ctx);
        } else return new ArrayList<>();
    }

    //Auxiliar functions

    public int firstScreen(Context ctx) {
        if(gestordades.checkFile(FilesName.FILEUSERTYPES, ctx)) {
            getUserTypes(ctx);
        }
        if(gestordades.checkFile(FilesName.FILESUBJECTS, ctx)) {
            getSubjects(ctx);
            if(gestordades.checkFile(FilesName.FILEGROUPS, ctx)) {
                getGroups(ctx);
                return 3; //content new qualification
            } else return 2; //content new student
        } else return 1; //content new subject
    }
}
